import { createHash, Hash } from 'crypto';
import { createReadStream } from 'fs';

export class Hashes {
	static async fileHash (path : string) : Promise<string> {
		return new Promise((resolve : Function, reject : Function) => {
			const hashSum : Hash = createHash('sha256');
			const stream : any = createReadStream(path);
			stream.on('error', (err : Error) => reject(err));
	    	stream.on('data', (chunk : Buffer) => hashSum.update(chunk));
	    	stream.on('end', () => resolve(hashSum.digest('hex')));
		});
	}

	static stringHash (str : string) : string {
		const sha : Hash = createHash('sha256').update(str);
		return sha.digest('hex');
	}
}

module.exports = { Hashes };